local modDir = g_currentModDirectory.. "extension/";
local modName = g_currentModName;

local specFile = Utils.getFilename("ViControl.lua", modDir);

function registerSpecialization(typeManager)

	if g_specializationManager:getSpecializationByName("ViControl") == nil then
		g_specializationManager:addSpecialization("ViControl", "ViControl", specFile, nil);
		print("Mod:  register ViControl(GroupManager) by HappyLooser");
	end;
	
    if typeManager.typeName == "vehicle" then
        for typeName, typeEntry in pairs(g_vehicleTypeManager:getTypes()) do
            if SpecializationUtil.hasSpecialization(Drivable, typeEntry.specializations)
			and SpecializationUtil.hasSpecialization(Motorized, typeEntry.specializations)
			and SpecializationUtil.hasSpecialization(Enterable, typeEntry.specializations) then
                g_vehicleTypeManager:addSpecialization(typeName, modName..".ViControl")
            end
        end
    end
end
TypeManager.validateTypes = Utils.appendedFunction(TypeManager.validateTypes, registerSpecialization);

ViControlMPEvent = {};
local ViControlMPEvent_mt = Class(ViControlMPEvent, Event);

InitEventClass(ViControlMPEvent, "ViControlMPEvent");

function ViControlMPEvent.emptyNew()
    local self = Event.new(ViControlMPEvent_mt);
    --self.className="ViControlMPEvent";
    return self;
end;

function ViControlMPEvent.new(object)
    local self = ViControlMPEvent.emptyNew()
    self.object = object;
    return self;
end;

function ViControlMPEvent:readStream(streamId, connection)	
    self.object = NetworkUtil.readNodeObject(streamId);	
	
	--[[print("ViControlMPEvent:readStream(streamId, connection)")
	for k,v in pairs(self.object) do 
		print(tostring(k).." : "..tostring(v));
	end;]]
	
	self.object.viControl.groupTyp = streamReadInt8(streamId);
	
	--self.object:setViControlKey(self.object.viControl.groupTyp);
	
	if not connection:getIsServer() then -- if server read then send to clients
		g_server:broadcastEvent(ViControlMPEvent.new(self.object), nil, connection, self.object);
	end;

end;

function ViControlMPEvent:writeStream(streamId, connection)
	--[[print("ViControlMPEvent:readStream(streamId, connection)")
	for k,v in pairs(self.object) do 
		print(tostring(k).." : "..tostring(v));
	end;]]
    NetworkUtil.writeNodeObject(streamId, self.object);	
	
	streamWriteInt8(streamId, self.object.viControl.groupTyp);	
end;

function ViControlMPEvent.updateSendEvent(runSelf)	

	if g_server ~= nil then
		g_server:broadcastEvent(ViControlMPEvent.new(runSelf), nil, nil, runSelf);
	else
		g_client:getServerConnection():sendEvent(ViControlMPEvent.new(runSelf));
	end;

end;

